; spconvRO.s
; Acorn-specific file for SPConv
;
; Author: Darren Salt


a1	RN	0
a2	RN	1
a3	RN	2
a4	RN	3
v1	RN	4
v2	RN	5
v3	RN	6
v4	RN	7
v5	RN	8
v6	RN	9
ip	RN	12
sp	RN	13
lr	RN	14
pc	RN	15

XOS_File	* &20008
XOS_SetVarVal	* &20024

	AREA	|C$$code|, CODE, READONLY


_setType
; int _setType(const char* filename, int filetype)
	STMFD	sp!,{v1-v3,lr}
	MOV	a3,a2
	MOV	a2,a1
	MOV	a1,#18
	SWI	XOS_File
	MOVVC	a1,#0
	LDMFD	sp!,{v1-v3,pc}^


fileType
; int fileType(const char* filename)
	STMFD	sp!,{v1-v3,lr}
	MOV	a3,a2
	MOV	a2,a1
	MOV	a1,#5
	SWI	XOS_File
	MVNVS	a1,#0
	LDMVSFD	sp!,{v1-v3,pc}^
	TST	a3,#&80000000
	MVNPL	a1,#0
	MOVMI	a1,a3,LSL #12
	MOVMI	a1,a1,LSR #20
	LDMFD	sp!,{v1-v3,pc}^


stat
; int stat(const char* filename, struct stat *status)
	STMFD	sp!,{a2,v1-v3,lr}
	MOV	a2,a1
	MOV	a1,#5
	SWI	XOS_File
	MVNVS	a1,#0
	LDMVSFD	sp!,{a2,v1-v3,pc}^
	LDMFD	sp!,{a2}
	TEQ	a1,#0
	MVNEQ	a1,#0
	STRNE	v1,[a2]
	LDMFD	sp!,{v1-v3,pc}^


setvar
; int stat(const char* filename, struct stat *status)
	STMFD	sp!,{v1-v3,lr}
	MOVS	a2,a1
	ADREQ	a2,null
	ADR	a1,varname
	MOV	a3,#0
len	LDRB	a4,[a2,a3]
	TEQ	a4,#0
	ADDNE	a3,a3,#1
	BNE	len
	MOV	v1,#4
	SWI	XOS_SetVarVal
	LDMFD	sp!,{v1-v3,pc}^

varname
	=	"SNAtoTAP$Error"
null	=	0
	ALIGN


stricmp
; int stricmp(const char*, const char*)
	STMFD	sp!,{lr}
cmp	LDRB	a3,[a1],#1
	LDRB	a4,[a2],#1
	CMP	a3,#97
	RSBGES	lr,a3,#122
	SUBGE	a3,a3,#32
	CMP	a4,#97
	RSBGES	lr,a4,#122
	SUBGE	a4,a4,#32
	CMP	a3,a4
	BNE	cmpd
	TEQ	a3,#0
	BNE	cmp
	MOV	a1,#0
	LDMFD	sp!,{pc}^
cmpd	MOVLT	a1,#-1
	MOVGT	a1,#1
	LDMFD	sp!,{pc}^


	EXPORT	_setType
	EXPORT	fileType
	EXPORT	stat
	EXPORT	setvar
	EXPORT	stricmp
